searchNodes=[{"doc":"Authorize actions at the boundary of a contextPlease see the README.","ref":"Bodyguard.html","title":"Bodyguard","type":"module"},{"doc":"Authorize a user's action.Returns :ok on success, and {:error, reason} on failure.If params is a keyword list, it is converted to a map before passing down to the Bodyguard.Policy.authorize/3 callback. Otherwise, params is not changed.","ref":"Bodyguard.html#permit/4","title":"Bodyguard.permit/4","type":"function"},{"doc":"The same as permit/4, but raises Bodyguard.NotAuthorizedError on authorization failure.Returns :ok on success.If params is a keyword list, it is converted to a map before passing down to the Bodyguard.Policy.authorize/3 callback. Otherwise, params is not changed.Optionserror_message – a string to describe the error (default &quot;not authorized&quot;)error_status – the HTTP status code to raise with the error (default 403)","ref":"Bodyguard.html#permit!/5","title":"Bodyguard.permit!/5","type":"function"},{"doc":"The same as permit/4, but returns a boolean.","ref":"Bodyguard.html#permit?/4","title":"Bodyguard.permit?/4","type":"function"},{"doc":"Filter a query down to user-accessible items.The query is introspected by Bodyguard in an attempt to automatically determine the schema type. To succeed, query must be an atom (schema module name), an Ecto.Query, or a list of structs.This function exists primarily as a helper to import into a context and gain access to scoping for all schemas.defmodule MyApp.Blog do import Bodyguard def list_user_posts(user) do Blog.Post |&gt; scope(user) # &lt;-- defers to MyApp.Blog.Post.scope/3 |&gt; where(draft: false) |&gt; Repo.all end endIf params is a keyword list, it is converted to a map before passing down to the Bodyguard.Policy.authorize/3 callback. Otherwise, params is not changed.Optionsschema - if the schema of the query cannot be determined, you must manually specify the schema here","ref":"Bodyguard.html#scope/4","title":"Bodyguard.scope/4","type":"function"},{"doc":"","ref":"Bodyguard.html#t:opts/0","title":"Bodyguard.opts/0","type":"type"},{"doc":"Execute authorized actions in a composable way.An Action can be built up over the course of a request, providing a means to specify authorization parameters in the steps leading up to actually executing the job.When authorization fails, there is an opportunity to handle it using a fallback function before returning the final result.Authorization is performed by deferring to a Bodyguard.Policy.Fields:context – Context for the action:policy – Implementation of Bodyguard.Policy behaviour; defaults to the :context:user – The user to authorize:name – The name of the authorized action:auth_run? – If an authorization check has been performed:auth_result – Result of the authorization check:authorized? – If authorization has succeeded (default false):job – Function to execute if authorization passes; signature job(action):fallback – Function to execute if authorization fails; signature fallback(action):assigns – Generic parameters along for the rideController Exampledefmodule MyApp.Web.PostController do use MyApp.Web, :controller import Bodyguard.Action alias MyApp.Blog action_fallback MyApp.FallbackController plug Bodyguard.Plug.BuildAction, context: Blog, user: &amp;get_current_user/1 def index(conn, _) do run conn.assigns.action, fn(action) -&gt; posts = Blog.list_posts(action.user) render(conn, &quot;index.html&quot;, posts: posts) end end defp get_current_user(conn) do # ... end endVerbose Exampleimport Bodyguard.Action alias MyApp.Blog act(Blog) |&gt; put_user(get_current_user()) |&gt; put_policy(Blog.SomeSpecialPolicy) |&gt; assign(:drafts, true) |&gt; authorize(:list_posts) |&gt; put_job(fn action -&gt; Blog.list_posts(action.user, drafts_only: action.assigns.drafts) end) |&gt; put_fallback(fn _action -&gt; {:error, :not_found} end) |&gt; run()","ref":"Bodyguard.Action.html","title":"Bodyguard.Action","type":"module"},{"doc":"Initialize an Action.The context is assumed to implement Bodyguard.Policy callbacks. To specify a unique policy, use put_policy/2.The Action is considered unauthorized by default, until authorization is run.","ref":"Bodyguard.Action.html#act/1","title":"Bodyguard.Action.act/1","type":"function"},{"doc":"Put a new assign.","ref":"Bodyguard.Action.html#assign/3","title":"Bodyguard.Action.assign/3","type":"function"},{"doc":"Mark the Action as authorized, regardless of previous authorization.","ref":"Bodyguard.Action.html#force_authorized/1","title":"Bodyguard.Action.force_authorized/1","type":"function"},{"doc":"Mark the Action as unauthorized, regardless of previous authorization.","ref":"Bodyguard.Action.html#force_unauthorized/2","title":"Bodyguard.Action.force_unauthorized/2","type":"function"},{"doc":"Use the policy to perform authorization.The opts are merged in to the Action's assigns and passed as the params.See Bodyguard.permit/3 for details.","ref":"Bodyguard.Action.html#permit/3","title":"Bodyguard.Action.permit/3","type":"function"},{"doc":"Same as authorize/3 but raises on failure.","ref":"Bodyguard.Action.html#permit!/3","title":"Bodyguard.Action.permit!/3","type":"function"},{"doc":"Replace the assigns.","ref":"Bodyguard.Action.html#put_assigns/2","title":"Bodyguard.Action.put_assigns/2","type":"function"},{"doc":"Change the context.","ref":"Bodyguard.Action.html#put_context/2","title":"Bodyguard.Action.put_context/2","type":"function"},{"doc":"Change the fallback handler.","ref":"Bodyguard.Action.html#put_fallback/2","title":"Bodyguard.Action.put_fallback/2","type":"function"},{"doc":"Change the job to execute.","ref":"Bodyguard.Action.html#put_job/2","title":"Bodyguard.Action.put_job/2","type":"function"},{"doc":"Change the policy.","ref":"Bodyguard.Action.html#put_policy/2","title":"Bodyguard.Action.put_policy/2","type":"function"},{"doc":"Change the user to authorize.","ref":"Bodyguard.Action.html#put_user/2","title":"Bodyguard.Action.put_user/2","type":"function"},{"doc":"Execute the Action's job.The job must have been previously assigned using put_job/2.If authorized, the job is run and its value is returned.If unauthorized, and a fallback has been provided, the fallback is run and its value returned.Otherwise, the result of the authorization is returned (something like {:error, reason}).","ref":"Bodyguard.Action.html#run/1","title":"Bodyguard.Action.run/1","type":"function"},{"doc":"Execute the given job.If authorized, the job is run and its value is returned.If unauthorized, and a fallback has been provided, the fallback is run and its value returned.Otherwise, the result of the authorization is returned (something like {:error, reason}).","ref":"Bodyguard.Action.html#run/2","title":"Bodyguard.Action.run/2","type":"function"},{"doc":"Execute the given job and fallback.If authorized, the job is run and its value is returned.If unauthorized, the fallback is run and its value returned.","ref":"Bodyguard.Action.html#run/3","title":"Bodyguard.Action.run/3","type":"function"},{"doc":"Execute the job, raising on failure.The job must have been previously assigned using put_job/2.","ref":"Bodyguard.Action.html#run!/1","title":"Bodyguard.Action.run!/1","type":"function"},{"doc":"Execute the given job, raising on failure.","ref":"Bodyguard.Action.html#run!/2","title":"Bodyguard.Action.run!/2","type":"function"},{"doc":"","ref":"Bodyguard.Action.html#t:assigns/0","title":"Bodyguard.Action.assigns/0","type":"type"},{"doc":"","ref":"Bodyguard.Action.html#t:fallback/0","title":"Bodyguard.Action.fallback/0","type":"type"},{"doc":"","ref":"Bodyguard.Action.html#t:job/0","title":"Bodyguard.Action.job/0","type":"type"},{"doc":"","ref":"Bodyguard.Action.html#t:t/0","title":"Bodyguard.Action.t/0","type":"type"},{"doc":"Work with Actions embedded in connections.","ref":"Bodyguard.Plug.html","title":"Bodyguard.Plug","type":"module"},{"doc":"Assign an Action to the connection.Inserts it into conn.assigns.action.","ref":"Bodyguard.Plug.html#put_action/3","title":"Bodyguard.Plug.put_action/3","type":"function"},{"doc":"Modify the existing Action on the connection, in-place.","ref":"Bodyguard.Plug.html#update_action/3","title":"Bodyguard.Plug.update_action/3","type":"function"},{"doc":"Perform authorization in a Plug pipeline.Options:policy required - the policy (or context) module:action required - the action, or a getter:user - the user getter:params - the params, or a getter, to pass to the authorization callbacks:fallback - a fallback controller or plug to handle authorization failure. If specified, the plug is called and then the pipeline is halted. If not specified, then Bodyguard.NotAuthorizedError raises directly to the router.Option GettersThe options :action, :user, and :params can accept getter functions that are either:an anonymous 1-arity function that accepts the conn and returns a valuea {module, function_name} tuple specifying an existing function with that same signatureDefault Plug OptionsYou can provide default options for this plug by simply wrapping your own plug around it. For example, if you're using Phoenix with Pow for authentication, you might want to specify:defmodule MyAppWeb.Authorize do def init(opts) do opts |&gt; Keyword.put_new(:action, {Phoenix.Controller, :action_name}) |&gt; Keyword.put_new(:user, {Pow.Plug, :current_user}) |&gt; Bodyguard.Plug.Authorize.init() end def call(conn, opts) do Bodyguard.Plug.Authorize.call(conn, opts) end endExamples# Raise on failure plug Bodyguard.Plug.Authorize, policy: MyApp.Blog, action: &amp;action_name/1, user: {MyApp.Authentication, :current_user} # Fallback on failure plug Bodyguard.Plug.Authorize, policy: MyApp.Blog, action: &amp;action_name/1, user: {MyApp.Authentication, :current_user}, fallback: MyAppWeb.FallbackController # Params as a function plug Bodyguard.Plug.Authorize, policy: MyApp.Blog, action: &amp;action_name/1, user: {MyApp.Authentication, :current_user}, params: &amp;get_params/1","ref":"Bodyguard.Plug.Authorize.html","title":"Bodyguard.Plug.Authorize","type":"module"},{"doc":"Callback implementation for Plug.call/2.","ref":"Bodyguard.Plug.Authorize.html#call/2","title":"Bodyguard.Plug.Authorize.call/2","type":"function"},{"doc":"Callback implementation for Plug.init/1.","ref":"Bodyguard.Plug.Authorize.html#init/1","title":"Bodyguard.Plug.Authorize.init/1","type":"function"},{"doc":"","ref":"Bodyguard.Plug.Authorize.html#valid_getter?/1","title":"Bodyguard.Plug.Authorize.valid_getter?/1","type":"function"},{"doc":"Construct an Action on the connection.The action is stored in conn.assigns.action for later access (configurable via the :key option).OptionsSee Bodyguard.Action for descriptions of these fields.context - context modulepolicy - policy module (defaults to context module)fallback - fallback functionassigns - action assignsuser – can be a 1-arity function (or {module, function_name}) that accepts the connection and returns the userkey - the assign to set. Defaults to :action","ref":"Bodyguard.Plug.BuildAction.html","title":"Bodyguard.Plug.BuildAction","type":"module"},{"doc":"Callback implementation for Plug.call/2.","ref":"Bodyguard.Plug.BuildAction.html#call/2","title":"Bodyguard.Plug.BuildAction.call/2","type":"function"},{"doc":"Callback implementation for Plug.init/1.","ref":"Bodyguard.Plug.BuildAction.html#init/1","title":"Bodyguard.Plug.BuildAction.init/1","type":"function"},{"doc":"Where authorization rules live.Typically the callbacks are designed to be used by Bodyguard.permit/4 and are not called directly.The only requirement is to implement the authorize/3 callback:defmodule MyApp.MyContext do @behaviour Bodyguard.Policy def authorize(action, user, params) do # Return :ok or true to permit # Return :error, {:error, reason}, or false to deny end endTo perform authorization checks, use Bodyguard.permit/4 and friends:with :ok &lt;- Bodyguard.permit(MyApp.MyContext, :action_name, user, param: :value) do # ... end if Bodyguard.permit?(MyApp.MyContext, :action_name, user, param: :value) do # ... end Bodyguard.permit!(MyApp.MyContext, :action_name, user, param: :value)If you want to define the callbacks in another module, you can use defdelegate:defmodule MyApp.MyContext do defdelegate authorize(action, user, params), to: Some.Other.Policy end","ref":"Bodyguard.Policy.html","title":"Bodyguard.Policy","type":"behaviour"},{"doc":"Callback to authorize a user's action.To permit an action, return :ok or true. To deny, return :error, {:error, reason}, or false.The action is whatever user-specified contextual action is being authorized. It bears no intrinsic relationship to a controller action, and instead should share a name with a particular function on the context.","ref":"Bodyguard.Policy.html#c:authorize/3","title":"Bodyguard.Policy.authorize/3","type":"callback"},{"doc":"","ref":"Bodyguard.Policy.html#t:auth_result/0","title":"Bodyguard.Policy.auth_result/0","type":"type"},{"doc":"Specify user-accessible items.The callbacks are designed to live within your schemas, hidden from the context boundaries of your application.All you have to do is implement the scope/3 callback on your schema. What &quot;access&quot; means is up to you, and can be customized on a case-by-case basis via params.Typically the callbacks are designed to be used by Bodyguard.scope/4 and are not called directly.If you want to use separate module for scoping, you can use defdelegate:defmodule MyApp.MyModel.MySchema do defdelegate scope(query, user, params), to: Some.Other.Scope end","ref":"Bodyguard.Schema.html","title":"Bodyguard.Schema","type":"behaviour"},{"doc":"Specify user-accessible items.This callback is expected to take a query of this schema and filter it down to results that are only accessible to user. Arbitrary params may also be specified.defmodule MyApp.MyModel.MySchema do @behaviour Bodyguard.Schema import Ecto.Query, only: [from: 2] def scope(query, user, _params) do from ms in query, where: ms.user_id == ^user.id end end","ref":"Bodyguard.Schema.html#c:scope/3","title":"Bodyguard.Schema.scope/3","type":"callback"},{"doc":"Raised when authorization fails.","ref":"Bodyguard.NotAuthorizedError.html","title":"Bodyguard.NotAuthorizedError","type":"exception"},{"doc":"Bodyguard Bodyguard protects the context boundaries of your application. 💪Version 2 was built from the ground-up to integrate nicely with Phoenix contexts. Authorization callbacks are implemented directly on contexts, so permissions can be checked from controllers, views, sockets, tests, and even other contexts.The Bodyguard.Policy behaviour is implemented with a single required callback. Additionally, the Bodyguard.Schema behaviour provides a convention for limiting query results per-user.This is an all-new API, so refer to the 1.x branch for the earlier readme.Docs ← complete documentationHexGitHub","ref":"readme.html","title":"Bodyguard","type":"extras"},{"doc":"Define authorization rules directly in the context module:# lib/my_app/blog/blog.ex defmodule MyApp.Blog do @behaviour Bodyguard.Policy # Admins can update anything def authorize(:update_post, %{role: :admin} = _user, _post), do: :ok # Users can update their owned posts def authorize(:update_post, %{id: user_id} = _user, %{user_id: user_id} = _post), do: :ok # Otherwise, denied def authorize(:update_post, _user, _post), do: :error end # lib/my_app_web/controllers/post_controller.ex defmodule MyAppWeb.PostController do use MyAppWeb, :controller def update(conn, %{&quot;id&quot; =&gt; id, &quot;post&quot; =&gt; post_params}) do user = conn.assigns.current_user post = MyApp.Blog.get_post!(id) with :ok &lt;- Bodyguard.permit(MyApp.Blog, :update_post, user, post), {:ok, post} &lt;- MyApp.Blog.update_post(post, post_params) do redirect(conn, to: post_path(conn, :show, post)) end end end","ref":"readme.html#quick-example","title":"Bodyguard - Quick Example","type":"extras"},{"doc":"To implement a policy, add @behaviour Bodyguard.Policy to a context, then define authorize(action, user, params) callbacks, which must return::ok or true to permit an action:error, {:error, reason}, or false to deny an actionDon't use these callbacks directly - instead, go through Bodyguard.permit/4. This will convert any keyword-list params into a map, and will coerce the callback result into a strict :ok or {:error, reason} result. The default failure reason is :unauthorized unless specified otherwise in the callback.Also provided are Bodyguard.permit?/4 (returns a boolean) and Bodyguard.permit!/5 (raises Bodyguard.NotAuthorizedError on failure).# lib/my_app/blog/blog.ex defmodule MyApp.Blog do @behaviour Bodyguard.Policy alias __MODULE__ # Admin users can do anything def authorize(_, %Blog.User{role: :admin}, _), do: true # Regular users can create posts def authorize(:create_post, _, _), do: true # Regular users can modify their own posts def authorize(action, %Blog.User{id: user_id}, %Blog.Post{user_id: user_id}) when action in [:update_post, :delete_post], do: true # Catch-all: deny everything else def authorize(_, _, _), do: false endIf you prefer more structure, define a dedicated policy module outside of the context, and use defdelegate:# lib/my_app/blog/blog.ex defmodule MyApp.Blog do defdelegate authorize(action, user, params), to: MyApp.Blog.Policy end # lib/my_app/blog/policy.ex defmodule MyApp.Blog.Policy do @behaviour Bodyguard.Policy def authorize(action, user, params), do: # ... end","ref":"readme.html#policies","title":"Bodyguard - Policies","type":"extras"},{"doc":"Phoenix 1.3 introduces the action_fallback controller macro. This is the recommended way to deal with authorization failures. The fallback controller will handle {:error, reason} authorization failures.Typically, authorization failure results in {:error, :unauthorized}. If you wish to deny access without leaking the existence of a particular resource, consider returning {:error, :not_found} instead, and handle it separately in the fallback controller.See the section &quot;Overriding action/2 for custom arguments&quot; in the Phoenix.Controller docs for a clean way to pass in the user to each action.# lib/my_app_web/controllers/fallback_controller.ex defmodule MyAppWeb.FallbackController do use MyAppWeb, :controller def call(conn, {:error, :unauthorized}) do conn |&gt; put_status(:forbidden) |&gt; put_view(MyAppWeb.ErrorView) |&gt; render(:&quot;403&quot;) end endWhere Should I Perform Checks?Bodyguard doesn't make any assumptions about where authorization checks are performed. You can do it before calling into the context, or within the context itself. There is a good discussion of the tradeoffs here.","ref":"readme.html#controllers","title":"Bodyguard - Controllers","type":"extras"},{"doc":"Bodyguard.Plug.Authorize – perform authorization in the middle of a pipelineThis plug's config utilizes callback functions called getters, which are 1-arity functions that accept the conn and return the appropriate value.# lib/my_app_web/controllers/post_controller.ex defmodule MyAppWeb.PostController do use MyAppWeb, :controller # Fetch the post and put into conn assigns plug :get_post when action in [:show] # Do the check plug Bodyguard.Plug.Authorize, policy: MyApp.Blog.Policy, action: {Phoenix.Controller, :action_name}, user: {MyApp.Authentication, :current_user}, params: {__MODULE__, :extract_post} def show(conn, _) do # Already assigned and authorized render(conn, &quot;show.html&quot;) end defp get_post(conn, _) do assign(conn, :post, MyApp.Posts.get_post!(conn.params[&quot;id&quot;])) end # Helper for the Authorize plug def extract_post(conn), do: conn.assigns.posts endSee the docs for more information about configuring application-wide defaults for the plug.","ref":"readme.html#plugs","title":"Bodyguard - Plugs","type":"extras"},{"doc":"Bodyguard also provides the Bodyguard.Schema behaviour to query which items a user can access. Implement it directly on schema modules.# lib/my_app/blog/post.ex defmodule MyApp.Blog.Post do import Ecto.Query, only: [from: 2] @behaviour Bodyguard.Schema def scope(query, %MyApp.Blog.User{id: user_id}, _) do from ms in query, where: ms.user_id == ^user_id end endTo leverage scopes, the Bodyguard.scope/4 helper function (not the callback!) can infer the type of a query and automatically defer to the appropriate callback.# lib/my_app/blog/blog.ex defmodule MyApp.Blog do def list_user_posts(user) do MyApp.Blog.Post |&gt; Bodyguard.scope(user) # &lt;-- defers to MyApp.Blog.Post.scope/3 |&gt; where(draft: false) |&gt; Repo.all end end","ref":"readme.html#schema-scopes","title":"Bodyguard - Schema Scopes","type":"extras"},{"doc":"Here is the default library config.config :bodyguard, default_error: :unauthorized # The second element of the {:error, reason} tuple returned on auth failure","ref":"readme.html#configuration","title":"Bodyguard - Configuration","type":"extras"},{"doc":"Testing is pretty straightforward – use the Bodyguard top-level API.assert :ok == Bodyguard.permit(MyApp.Blog, :successful_action, user) assert {:error, :unauthorized} == Bodyguard.permit(MyApp.Blog, :failing_action, user) assert Bodyguard.permit?(MyApp.Blog, :successful_action, user) refute Bodyguard.permit?(MyApp.Blog, :failing_action, user) error = assert_raise Bodyguard.NotAuthorizedError, fun -&gt; Bodyguard.permit(MyApp.Blog, :failing_action, user) end assert %{status: 403, message: &quot;not authorized&quot;} = error","ref":"readme.html#testing","title":"Bodyguard - Testing","type":"extras"},{"doc":"Add bodyguard to your list of dependencies:# mix.exs def deps do [{:bodyguard, &quot;~&gt; 2.4&quot;}] endCreate an error view for handling 403 Forbidden.# lib/my_app_web/views/error_view.ex defmodule MyAppWeb.ErrorView do use MyAppWeb, :view def render(&quot;403.html&quot;, _assigns) do &quot;Forbidden&quot; end endWire up a fallback controller to render this error view on {:error, :unauthorized}.Add @behaviour Bodyguard.Policy to contexts that require authorization, and implement authorize/3 callbacks.(Optional) Add @behaviour Bodyguard.Schema on schemas available for user-scoping, and implement scope/3 callbacks.(Optional) Edit my_app_web.ex and add import Bodyguard to controllers, views, channels, etc.","ref":"readme.html#installation","title":"Bodyguard - Installation","type":"extras"},{"doc":"Not what you're looking for?Roll your ownPolicyWonkCanadaCanary","ref":"readme.html#alternatives","title":"Bodyguard - Alternatives","type":"extras"},{"doc":"Join our communities!Slack","ref":"readme.html#community","title":"Bodyguard - Community","type":"extras"},{"doc":"MIT License, Copyright (c) 2017 Rockwell Schrock","ref":"readme.html#license","title":"Bodyguard - License","type":"extras"},{"doc":"Thanks to Ben Cates for helping maintain and mature this library.","ref":"readme.html#acknowledgements","title":"Bodyguard - Acknowledgements","type":"extras"}]